; Command-line commands
; No arguments command
execShutdown:
	call suspendDevice
	ret
	
execClrIO:
	call clearTextBuf
	ret
	
execPing:
	ld hl,pingStr
	call printString
	ret

execVersion:
	; see boot.asm for welcomeString
	ld hl,welcomeString
	call printString
	ret

execEcho:
	ld hl,inputBufArgsSec
	call printString
	ret
	
execFileInfo:
	ld hl,inputBufArgsSec
	push hl
		call getStrLength
	pop hl
	ld a,10
	cp c
	jr nc,_execFileInfoValidName
	ld hl,fileNameTooLong
	call printString
	ret
_execFileInfoValidName:
	ld de,nameArea
	ld b,0
	ldir
	xor a
	dec de
	dec de
	ld (de),a
	call findVar
	jr c,_execFileInfoNoFile
	; prints executable byte
	push hl
		ld hl,fileInfoExecutable
		call printString
	pop hl
	ld a,(hl)
	dec a
	call printHex
	ld a,'\n'
	call putC
	; prints page
	push hl
		ld hl,fileInfoPage
		call printString
	pop hl
	inc hl
	ld a,(hl)
	call printHex
	ld a,'\n'
	call putC
	; prints file size
	ld hl,fileInfoSize1
	call printString
	ex de,hl
	dec hl
	dec hl
	ld b,(hl)
	inc hl
	ld a,(hl)
	call printHex
	ld a,b
	call printHex
	ld hl,fileInfoSize2
	call printString
	ret
_execFileInfoNoFile:
	ld hl,fileNotFound
	call printString
	ret
	
pingStr:
	.db "Pong !\n",0

fileNameTooLong:
	.db "File name too long\n",0
fileInfoExecutable:
	.db "Executable : ",0
fileInfoPage:
	.db "File in page ",0
fileInfoSize1:
	.db "File size : ",0
fileInfoSize2:
	.db " bytes\n",0
fileNotFound:
	.db "File doesn't exist\n",0