; file system-related functions

; File header :
;	executable (1 byte) : 1 -> no, 2 -> yes, everything else -> end of filesystem
;	page (1 byte)
;	zero-terminated name (2 to 10 bytes)
;	data size (2 bytes)
;	data

; Inputs :
;	(nameArea) = zero-terminated name
; Outputs :
;	If file found :
;		hl = pointer on first byte of file's header
;		de = pointer on data
;		carry unset
;	If file not found :
;		carry set
findVar:
	ld de,fileSystemStart
	push de
		ld hl,nameArea
		ld a,(de)
		dec a
		cp 2
		ccf
	pop de			;
	ret c			; erf
	push de			;
		inc de
		inc de
		call compareZeroTerminatedStrings
	pop de
	push de \ pop hl
	inc hl
	inc hl
	push af
		call getStrLength ; go to end of name
		inc hl
	pop af
	jr nz,_findVarNoMatch

	inc hl
	inc hl
	ex de,hl
	ret
_findVarNoMatch:
	ld a,(hl)
	ld e,a
	inc hl
	ld a,(hl)
	ld d,a
	inc hl
	add hl,de
	ex de,hl
	jr findVar+3