sysInterrupt:
    di
    exx
    ex af, af'
    ; Determine the kind of interrut we're dealing with
#ifdef USB
    jp usbInterrupt
interruptResume:
#endif
    in a, (4)
    bit 0, a
    jr nz, intHandleON
    bit 1, a
    jr nz, intHandleTimer1
    bit 2, a
    jr nz, intHandleTimer2
    bit 4, a
    jr nz, intHandleLink
    jr sysInterruptDone
    
intHandleON:
    in a, (3)
    res 0, a
    out (3), a
    set 0, a
    out (3), a
    jr sysInterruptDone
    
intHandleTimer1:
    in a, (3)
    res 1, a
    out (3), a
    set 1, a
    out (3), a
    jr sysInterruptDone
    
intHandleTimer2:
    in a, (3)
    res 2, a
    out (3), a
    set 2, a
    out (3), a
    jr sysInterruptDone
    
intHandleLink:
    in a, (3)
    res 4, a
    out (3), a
    set 4, a
    out (3), a

sysInterruptDone:
    exx
    ex af, af'
    ei
    ret
    
#ifdef USB
usbInterrupt:
    in a, (0x55) ; USB Interrupt status
    bit 0, a
    jr z, usbUnknownEvent
    bit 2, a
    jr z, usbLineEvent
    bit 4, a
    jr z, usbProtocolEvent
    jp interruptResume
    
usbUnknownEvent:
    jp interruptResume
    
usbLineEvent:
    in a, (0x56) ; USB Line Events
    xor 0xFF
    out (0x57), a ; Acknowledge interrupt and disable further interrupts
    jp interruptResume
    
usbProtocolEvent:
    in a, (0x82)
    in a, (0x83)
    in a, (0x84)
    in a, (0x85)
    in a, (0x86) ; Merely reading from these will acknowledge the interrupt
    jp interruptResume
#endif
