; Various utility functions.

suspendDevice:
    ld a, i
    push af
    ld a, 2
    out (0x10), a ; Disable LCD
    di ; And interrupts, for now
    im 1 ; interrupt mode 1, for cleanliness
    ei ; Enable interrupting when ON is pressed
    ld a, 1
    out (0x03), a ; ON
    halt ; and halt
    di
    ld a, 0x0B ; Reset the interrupts
    out (0x03), a
    ld a, 3
    out (0x10), a ; Enable the screen
    pop af
    ret po
    ei
    ret

lcdDelay:
    push af
_:  in a, (0x10)
    rla
    jr c, -_
    pop af
    ret

; Inputs :
;	hl = amount of frames to pause (1800 ~ 1 second)
; Outputs :
;	calc paused for the given amount of time
pause:	
	djnz $
	dec hl
	ld a,h
	or l
	jr nz,pause
	ret
	
; Inputs :
;	hl = pointer on zone to fill
;	a = byte to fill with
;	bc = amount of bytes to fill
; Outputs :
;	bc bytes starting at hl filled with a
memset:
	saveRegs
	
	ld (hl),a
	push hl \ pop de
	inc de
	ldir
	
	restoreRegs
	ret
